diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-l3-protocol.cc ns-3.31/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.30.1/src/internet/model/ipv6-l3-protocol.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-l3-protocol.cc	2020-06-27 17:38:30.000000000 -0700
@@ -44,6 +44,7 @@
 #include "ipv6-option.h"
 #include "icmpv6-l4-protocol.h"
 #include "ndisc-cache.h"
+#include "ipv6-raw-socket-factory-impl.h"
 
 /// Minimum IPv6 MTU, as defined by \RFC{2460}
 #define IPV6_MIN_MTU 1280
@@ -125,18 +126,21 @@
 Ipv6L3Protocol::Ipv6L3Protocol ()
   : m_nInterfaces (0)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_pmtuCache = CreateObject<Ipv6PmtuCache> ();
+  
+  Ptr<Ipv6RawSocketFactoryImpl> rawFactoryImpl = CreateObject<Ipv6RawSocketFactoryImpl> ();
+  AggregateObject (rawFactoryImpl);
 }
 
 Ipv6L3Protocol::~Ipv6L3Protocol ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 void Ipv6L3Protocol::DoDispose ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   /* clear protocol and interface list */
   for (L4List_t::iterator it = m_protocols.begin (); it != m_protocols.end (); ++it)
@@ -184,7 +188,7 @@
 
 Ptr<Ipv6RoutingProtocol> Ipv6L3Protocol::GetRoutingProtocol () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_routingProtocol;
 }
 
@@ -234,7 +238,7 @@
 
 uint32_t Ipv6L3Protocol::GetNInterfaces () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_nInterfaces;
 }
 
@@ -308,24 +312,7 @@
 
   if (flags & (1 << 6)) /* auto flag */
     {
-      // In case of new MacAddress types, remember to change Ipv6L3Protocol::RemoveAutoconfiguredAddress as well
-      if (Mac64Address::IsMatchingType (addr))
-        {
-          address = Ipv6InterfaceAddress (Ipv6Address::MakeAutoconfiguredAddress (Mac64Address::ConvertFrom (addr), network));
-        }
-      else if (Mac48Address::IsMatchingType (addr))
-        {
-          address = Ipv6InterfaceAddress (Ipv6Address::MakeAutoconfiguredAddress (Mac48Address::ConvertFrom (addr), network));
-        }
-      else if (Mac16Address::IsMatchingType (addr))
-        {
-          address = Ipv6InterfaceAddress (Ipv6Address::MakeAutoconfiguredAddress (Mac16Address::ConvertFrom (addr), network));
-        }
-      else
-        {
-          NS_FATAL_ERROR ("Unknown method to make autoconfigured address for this kind of device.");
-          return;
-        }
+      address = Ipv6Address::MakeAutoconfiguredAddress (addr, network);
 
       /* see if we have already the prefix */
       for (Ipv6AutoconfiguredPrefixListI it = m_prefixes.begin (); it != m_prefixes.end (); ++it)
@@ -363,37 +350,18 @@
   NS_LOG_FUNCTION (this << interface << network << mask);
   Ptr<Ipv6Interface> iface = GetInterface (interface);
   Address addr = iface->GetDevice ()->GetAddress ();
-  uint32_t max = iface->GetNAddresses ();
-  uint32_t i = 0;
-  Ipv6Address toFound;
-
-  if (Mac64Address::IsMatchingType (addr))
-    {
-      toFound = Ipv6Address::MakeAutoconfiguredAddress (Mac64Address::ConvertFrom (addr), network);
-    }
-  else if (Mac48Address::IsMatchingType (addr))
-    {
-      toFound = Ipv6Address::MakeAutoconfiguredAddress (Mac48Address::ConvertFrom (addr), network);
-    }
-  else if (Mac16Address::IsMatchingType (addr))
-    {
-      toFound = Ipv6Address::MakeAutoconfiguredAddress (Mac16Address::ConvertFrom (addr), network);
-    }
-  else
-    {
-      NS_FATAL_ERROR ("Unknown method to make autoconfigured address for this kind of device.");
-      return;
-    }
+  
+  Ipv6Address addressToFind = Ipv6Address::MakeAutoconfiguredAddress (addr, network);
 
-  for (i = 0; i < max; i++)
+  for (uint32_t i = 0; i < iface->GetNAddresses (); i++)
     {
-      if (iface->GetAddress (i).GetAddress () == toFound)
+      if (iface->GetAddress (i).GetAddress () == addressToFind)
         {
           RemoveAddress (interface, i);
           break;
         }
     }
-
+  
   /* remove from list of autoconfigured address */
   for (Ipv6AutoconfiguredPrefixListI it = m_prefixes.begin (); it != m_prefixes.end (); ++it)
     {
@@ -557,7 +525,7 @@
 
 void Ipv6L3Protocol::SetupLoopback ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   Ptr<Ipv6Interface> interface = CreateObject<Ipv6Interface> ();
   Ptr<LoopbackNetDevice> device = 0;
   uint32_t i = 0;
@@ -660,7 +628,7 @@
 
 bool Ipv6L3Protocol::GetIpForward () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_ipForward;
 }
 
@@ -684,13 +652,13 @@
 
 bool Ipv6L3Protocol::GetSendIcmpv6Redirect () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_sendIcmpv6Redirect;
 }
 
 void Ipv6L3Protocol::NotifyNewAggregate ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   if (m_node == 0)
     {
@@ -702,6 +670,7 @@
           this->SetNode (node);
         }
     }
+  
   Ipv6::NotifyNewAggregate ();
 }
 
@@ -804,7 +773,7 @@
 
 Ptr<Socket> Ipv6L3Protocol::CreateRawSocket ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   Ptr<Ipv6RawSocketImpl> sock = CreateObject<Ipv6RawSocketImpl> ();
   sock->SetNode (m_node);
   m_sockets.push_back (sock);
@@ -827,7 +796,7 @@
 
 Ptr<Icmpv6L4Protocol> Ipv6L3Protocol::GetIcmpv6 () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   Ptr<IpL4Protocol> protocol = GetProtocol (Icmpv6L4Protocol::GetStaticProtocolNumber ());
 
   if (protocol)
@@ -1059,7 +1028,7 @@
             {
               Ipv6InterfaceAddress iaddr = GetAddress (j, i);
               Ipv6Address addr = iaddr.GetAddress ();
-              if (addr.IsEqual (hdr.GetDestinationAddress ()))
+              if (addr == hdr.GetDestinationAddress ())
                 {
                   if (j == interface)
                     {
@@ -1159,7 +1128,7 @@
       ipv6Fragment->GetFragments (packet, ipHeader, targetMtu, fragments);
     }
 
-  if (!route->GetGateway ().IsEqual (Ipv6Address::GetAny ()))
+  if (route->GetGateway () != Ipv6Address::GetAny ())
     {
       if (outInterface->IsUp ())
         {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-list-routing.cc ns-3.31/src/internet/model/ipv6-list-routing.cc
--- ns-3.30.1/src/internet/model/ipv6-list-routing.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-list-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -46,18 +46,18 @@
 Ipv6ListRouting::Ipv6ListRouting ()
   : m_ipv6 (0)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 Ipv6ListRouting::~Ipv6ListRouting ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 void
 Ipv6ListRouting::DoDispose (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   for (Ipv6RoutingProtocolList::iterator rprotoIter = m_routingProtocols.begin ();
        rprotoIter != m_routingProtocols.end (); rprotoIter++)
     {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-option.cc ns-3.31/src/internet/model/ipv6-option.cc
--- ns-3.30.1/src/internet/model/ipv6-option.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-option.cc	2020-06-27 17:38:30.000000000 -0700
@@ -46,7 +46,7 @@
 
 Ipv6Option::~Ipv6Option ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 void Ipv6Option::SetNode (Ptr<Node> node)
@@ -70,17 +70,17 @@
 
 Ipv6OptionPad1::Ipv6OptionPad1 ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 Ipv6OptionPad1::~Ipv6OptionPad1 ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 uint8_t Ipv6OptionPad1::GetOptionNumber () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   return OPT_NUMBER;
 }
@@ -115,17 +115,17 @@
 
 Ipv6OptionPadn::Ipv6OptionPadn ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 Ipv6OptionPadn::~Ipv6OptionPadn ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 uint8_t Ipv6OptionPadn::GetOptionNumber () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   return OPT_NUMBER;
 }
@@ -160,17 +160,17 @@
 
 Ipv6OptionJumbogram::Ipv6OptionJumbogram ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 Ipv6OptionJumbogram::~Ipv6OptionJumbogram ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 uint8_t Ipv6OptionJumbogram::GetOptionNumber () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   return OPT_NUMBER;
 }
@@ -205,17 +205,17 @@
 
 Ipv6OptionRouterAlert::Ipv6OptionRouterAlert ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 Ipv6OptionRouterAlert::~Ipv6OptionRouterAlert ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 uint8_t Ipv6OptionRouterAlert::GetOptionNumber () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   return OPT_NUMBER;
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-raw-socket-impl.cc ns-3.31/src/internet/model/ipv6-raw-socket-impl.cc
--- ns-3.30.1/src/internet/model/ipv6-raw-socket-impl.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-raw-socket-impl.cc	2020-06-27 17:38:30.000000000 -0700
@@ -57,7 +57,7 @@
 
 Ipv6RawSocketImpl::Ipv6RawSocketImpl ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_err = Socket::ERROR_NOTERROR;
   m_node = 0;
   m_src = Ipv6Address::GetAny ();
@@ -74,7 +74,7 @@
 
 void Ipv6RawSocketImpl::DoDispose ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_node = 0;
   Socket::DoDispose ();
 }
@@ -92,7 +92,7 @@
 
 enum Socket::SocketErrno Ipv6RawSocketImpl::GetErrno () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_err;
 }
 
@@ -117,7 +117,7 @@
 
 int Ipv6RawSocketImpl::Bind ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_src = Ipv6Address::GetAny ();
   return 0;
 }
@@ -129,7 +129,7 @@
 
 int Ipv6RawSocketImpl::GetSockName (Address& address) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   address = Inet6SocketAddress (m_src, 0);
   return 0;
 }
@@ -152,7 +152,7 @@
 
 int Ipv6RawSocketImpl::Close ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   Ptr<Ipv6L3Protocol> ipv6 = m_node->GetObject<Ipv6L3Protocol> ();
 
   Ipv6LeaveGroup ();
@@ -165,14 +165,14 @@
 
 int Ipv6RawSocketImpl::ShutdownSend ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_shutdownSend = true;
   return 0;
 }
 
 int Ipv6RawSocketImpl::ShutdownRecv ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_shutdownRecv = true;
   return 0;
 }
@@ -194,7 +194,7 @@
 
 int Ipv6RawSocketImpl::Listen ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_err = Socket::ERROR_OPNOTSUPP;
   return -1;
 }
@@ -377,13 +377,13 @@
 
 uint32_t Ipv6RawSocketImpl::GetTxAvailable () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return 0xffffffff;
 }
 
 uint32_t Ipv6RawSocketImpl::GetRxAvailable () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   uint32_t rx = 0;
 
   for (std::list<Data>::const_iterator it = m_data.begin (); it != m_data.end (); ++it)
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-routing-table-entry.cc ns-3.31/src/internet/model/ipv6-routing-table-entry.cc
--- ns-3.30.1/src/internet/model/ipv6-routing-table-entry.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-routing-table-entry.cc	2020-06-27 17:38:30.000000000 -0700
@@ -108,7 +108,7 @@
 
 bool Ipv6RoutingTableEntry::IsHost () const
 {
-  if (m_destNetworkPrefix.IsEqual (Ipv6Prefix::GetOnes ()))
+  if (m_destNetworkPrefix == Ipv6Prefix::GetOnes ())
     {
       return true;
     }
@@ -137,7 +137,7 @@
 
 bool Ipv6RoutingTableEntry::IsDefault () const
 {
-  if (m_dest.IsEqual (Ipv6Address::GetZero ()))
+  if (m_dest == Ipv6Address::GetZero ())
     {
       return true;
     }
@@ -156,7 +156,7 @@
 
 bool Ipv6RoutingTableEntry::IsGateway () const
 {
-  if (m_gateway.IsEqual (Ipv6Address::GetZero ()))
+  if (m_gateway == Ipv6Address::GetZero ())
     {
       return false;
     }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-static-routing.cc ns-3.31/src/internet/model/ipv6-static-routing.cc
--- ns-3.30.1/src/internet/model/ipv6-static-routing.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-static-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -49,12 +49,12 @@
 Ipv6StaticRouting::Ipv6StaticRouting ()
   : m_ipv6 (0)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 Ipv6StaticRouting::~Ipv6StaticRouting ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 void Ipv6StaticRouting::SetIpv6 (Ptr<Ipv6> ipv6)
@@ -86,7 +86,7 @@
 
   *os << "Node: " << m_ipv6->GetObject<Node> ()->GetId ()
       << ", Time: " << Now().As (unit)
-      << ", Local time: " << GetObject<Node> ()->GetLocalTime ().As (unit)
+      << ", Local time: " << m_ipv6->GetObject<Node> ()->GetLocalTime ().As (unit)
       << ", Ipv6StaticRouting table" << std::endl;
 
   if (GetNRoutes () > 0)
@@ -201,7 +201,7 @@
 
 uint32_t Ipv6StaticRouting::GetNMulticastRoutes () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_multicastRoutes.size ();
 }
 
@@ -373,7 +373,7 @@
 
 void Ipv6StaticRouting::DoDispose ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   for (NetworkRoutesI j = m_networkRoutes.begin ();  j != m_networkRoutes.end (); j = m_networkRoutes.erase (j))
     {
@@ -447,7 +447,7 @@
 
 Ipv6RoutingTableEntry Ipv6StaticRouting::GetDefaultRoute ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   Ipv6Address dst ("::");
   uint32_t shortestMetric = 0xffffffff;
   Ipv6RoutingTableEntry* result = 0;
@@ -503,7 +503,7 @@
 
 uint32_t Ipv6StaticRouting::GetMetric (uint32_t index) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this << index);
   uint32_t tmp = 0;
 
   for (NetworkRoutesCI it = m_networkRoutes.begin (); it != m_networkRoutes.end (); it++)
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/loopback-net-device.cc ns-3.31/src/internet/model/loopback-net-device.cc
--- ns-3.30.1/src/internet/model/loopback-net-device.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/loopback-net-device.cc	2020-06-27 17:38:30.000000000 -0700
@@ -47,7 +47,7 @@
     m_ifIndex (0),
     m_address (Mac48Address ("00:00:00:00:00:00"))
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 void 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ndisc-cache.cc ns-3.31/src/internet/model/ndisc-cache.cc
--- ns-3.30.1/src/internet/model/ndisc-cache.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ndisc-cache.cc	2020-06-27 17:38:30.000000000 -0700
@@ -51,18 +51,18 @@
 
 NdiscCache::NdiscCache ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 NdiscCache::~NdiscCache ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   Flush ();
 }
 
 void NdiscCache::DoDispose ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   Flush ();
   m_device = 0;
   m_interface = 0;
@@ -80,13 +80,13 @@
 
 Ptr<Ipv6Interface> NdiscCache::GetInterface () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_interface;
 }
 
 Ptr<NetDevice> NdiscCache::GetDevice () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_device;
 }
 
@@ -97,7 +97,8 @@
   if (m_ndCache.find (dst) != m_ndCache.end ())
     {
       NdiscCache::Entry* entry = m_ndCache[dst];
-      NS_LOG_LOGIC ("Found an entry:" << dst << " to " << entry->GetMacAddress ());
+      NS_LOG_LOGIC ("Found an entry: " << *entry);
+
       return entry;
     }
   NS_LOG_LOGIC ("Nothing found");
@@ -114,7 +115,7 @@
       NdiscCache::Entry *entry = (*i).second;
       if (entry->GetMacAddress () == dst)
         {
-          NS_LOG_LOGIC ("Found an entry:" << (*i).first << " to " << (*i).second);
+          NS_LOG_LOGIC ("Found an entry:" << (*entry));
           entryList.push_back (entry);
         }
     }
@@ -135,7 +136,7 @@
 
 void NdiscCache::Remove (NdiscCache::Entry* entry)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this << entry);
 
   for (CacheI i = m_ndCache.begin (); i != m_ndCache.end (); i++)
     {
@@ -151,7 +152,7 @@
 
 void NdiscCache::Flush ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   for (CacheI i = m_ndCache.begin (); i != m_ndCache.end (); i++)
     {
@@ -169,7 +170,7 @@
 
 uint32_t NdiscCache::GetUnresQlen ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_unresQlen;
 }
 
@@ -214,13 +215,13 @@
           *os << " STALE\n";
         }
       else if (i->second->IsPermanent ())
-	{
-	  *os << " PERMANENT\n";
-	}
+        {
+          *os << " PERMANENT\n";
+        }
       else
-	{
-	  NS_FATAL_ERROR ("Test for possibly unreachable code-- please file a bug report, with a test case, if this is ever hit");
-	}
+        {
+          NS_FATAL_ERROR ("Test for possibly unreachable code-- please file a bug report, with a test case, if this is ever hit");
+        }
     }
 }
 
@@ -232,7 +233,7 @@
     m_lastReachabilityConfirmation (Seconds (0.0)),
     m_nsRetransmit (0)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 void NdiscCache::Entry::SetRouter (bool router)
@@ -243,7 +244,7 @@
 
 bool NdiscCache::Entry::IsRouter () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_router;
 }
 
@@ -262,20 +263,20 @@
 
 void NdiscCache::Entry::ClearWaitingPacket ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   /** \todo report packets as 'dropped' */
   m_waiting.clear ();
 }
 
 void NdiscCache::Entry::FunctionReachableTimeout ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   this->MarkStale ();
 }
 
 void NdiscCache::Entry::FunctionRetransmitTimeout ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   Ipv6Address addr;
 
   /* determine source address */
@@ -324,7 +325,7 @@
 
 void NdiscCache::Entry::FunctionDelayTimeout ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   Ipv6Address addr;
 
   this->MarkProbe ();
@@ -359,7 +360,7 @@
 
 void NdiscCache::Entry::FunctionProbeTimeout ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   if (m_nsRetransmit < m_ndCache->m_icmpv6->GetMaxUnicastSolicit ())
     {
@@ -410,13 +411,13 @@
 
 Time NdiscCache::Entry::GetLastReachabilityConfirmation () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_lastReachabilityConfirmation;
 }
 
 void NdiscCache::Entry::StartReachableTimer ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   if (m_nudTimer.IsRunning ())
     {
       m_nudTimer.Cancel ();
@@ -430,7 +431,7 @@
 
 void NdiscCache::Entry::UpdateReachableTimer ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   if (m_state == REACHABLE)
     {
@@ -445,7 +446,7 @@
 
 void NdiscCache::Entry::StartProbeTimer ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   if (m_nudTimer.IsRunning ())
     {
       m_nudTimer.Cancel ();
@@ -458,7 +459,7 @@
 
 void NdiscCache::Entry::StartDelayTimer ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   if (m_nudTimer.IsRunning ())
     {
       m_nudTimer.Cancel ();
@@ -471,7 +472,7 @@
 
 void NdiscCache::Entry::StartRetransmitTimer ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   if (m_nudTimer.IsRunning ())
     {
       m_nudTimer.Cancel ();
@@ -484,7 +485,7 @@
 
 void NdiscCache::Entry::StopNudTimer ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_nudTimer.Cancel ();
   m_nsRetransmit = 0;
 }
@@ -510,19 +511,19 @@
 
 void NdiscCache::Entry::MarkProbe ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_state = PROBE;
 }
 
 void NdiscCache::Entry::MarkStale ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_state = STALE;
 }
 
 void NdiscCache::Entry::MarkReachable ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_state = REACHABLE;
 }
 
@@ -536,56 +537,56 @@
 
 void NdiscCache::Entry::MarkDelay ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_state = DELAY;
 }
 
 void NdiscCache::Entry::MarkPermanent ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   StopNudTimer ();
   m_state = PERMANENT;
 }
 
 bool NdiscCache::Entry::IsStale () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return (m_state == STALE);
 }
 
 bool NdiscCache::Entry::IsReachable () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return (m_state == REACHABLE);
 }
 
 bool NdiscCache::Entry::IsDelay () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return (m_state == DELAY);
 }
 
 bool NdiscCache::Entry::IsIncomplete () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return (m_state == INCOMPLETE);
 }
 
 bool NdiscCache::Entry::IsProbe () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return (m_state == PROBE);
 }
 
 bool NdiscCache::Entry::IsPermanent () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return (m_state == PERMANENT);
 }
 
 Address NdiscCache::Entry::GetMacAddress () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_macAddress;
 }
 
@@ -595,5 +596,37 @@
   m_macAddress = mac;
 }
 
+void NdiscCache::Entry::Print (std::ostream &os) const
+{
+  os << m_ipv6Address << " lladdr " << m_macAddress << " state ";
+  switch (m_state)
+  {
+    case INCOMPLETE:
+      os << "INCOMPLETE";
+      break;
+    case REACHABLE:
+      os << "REACHABLE";
+      break;
+    case STALE:
+      os << "STALE";
+      break;
+    case DELAY:
+      os << "DELAY";
+      break;
+    case PROBE:
+      os << "PROBE";
+      break;
+    case PERMANENT:
+      os << "PERMANENT";
+      break;
+  }
+}
+
+std::ostream& operator << (std::ostream& os, NdiscCache::Entry const& entry)
+{
+  entry.Print (os);
+  return os;
+}
+
 } /* namespace ns3 */
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ndisc-cache.h ns-3.31/src/internet/model/ndisc-cache.h
--- ns-3.30.1/src/internet/model/ndisc-cache.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ndisc-cache.h	2020-06-27 17:38:30.000000000 -0700
@@ -89,7 +89,7 @@
    * \param dst destination address.
    * \return the entry if found, 0 otherwise.
    */
-  NdiscCache::Entry* Lookup (Ipv6Address dst);
+  virtual NdiscCache::Entry* Lookup (Ipv6Address dst);
 
   /**
    * \brief Lookup in the cache for a MAC address.
@@ -103,7 +103,7 @@
    * \param to address to add
    * \return an new Entry
    */
-  NdiscCache::Entry* Add (Ipv6Address to);
+  virtual NdiscCache::Entry* Add (Ipv6Address to);
 
   /**
    * \brief Delete an entry.
@@ -162,6 +162,8 @@
      */
     Entry (NdiscCache* nd);
 
+    virtual ~Entry() = default;
+
     /**
      * \brief Changes the state to this entry to INCOMPLETE.
      * \param p packet that wait to be sent
@@ -342,6 +344,19 @@
      */
     void SetIpv6Address (Ipv6Address ipv6Address);
 
+    /**
+     * \brief Print this entry to the given output stream.
+     *
+     * \param os the output stream to which this Ipv6Address is printed
+     */
+    void Print (std::ostream &os) const;
+
+protected:
+    /**
+     * \brief the NdiscCache associated.
+     */
+    NdiscCache* m_ndCache;
+
 private:
     /**
      * \brief The IPv6 address.
@@ -367,11 +382,6 @@
     NdiscCacheEntryState_e m_state;
 
     /**
-     * \brief the NdiscCache associated.
-     */
-    NdiscCache* m_ndCache;
-
-    /**
      * \brief The MAC address.
      */
     Address m_macAddress;
@@ -402,7 +412,12 @@
     uint8_t m_nsRetransmit;
   };
 
-private:
+protected:
+  /**
+   * \brief Dispose this object.
+   */
+  void DoDispose ();
+
   /**
    * \brief Neighbor Discovery Cache container
    */
@@ -413,6 +428,14 @@
   typedef sgi::hash_map<Ipv6Address, NdiscCache::Entry *, Ipv6AddressHash>::iterator CacheI;
 
   /**
+   * \brief A list of Entry.
+   */
+  Cache m_ndCache;
+
+
+private:
+
+  /**
    * \brief Copy constructor.
    *
    * Not implemented to avoid misuse
@@ -428,11 +451,6 @@
   NdiscCache& operator= (NdiscCache const &);
 
   /**
-   * \brief Dispose this object.
-   */
-  void DoDispose ();
-
-  /**
    * \brief The NetDevice.
    */
   Ptr<NetDevice> m_device;
@@ -448,16 +466,21 @@
   Ptr<Icmpv6L4Protocol> m_icmpv6;
 
   /**
-   * \brief A list of Entry.
-   */
-  Cache m_ndCache;
-
-  /**
    * \brief Max number of packet stored in m_waiting.
    */
   uint32_t m_unresQlen;
 };
 
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the reference to the output stream
+ * \param entry the NdiscCache::Entry
+ * \returns the reference to the output stream
+ */
+std::ostream & operator << (std::ostream& os, NdiscCache::Entry const& entry);
+
+
 } /* namespace ns3 */
 
 #endif /* NDISC_CACHE_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/nsc-tcp-socket-impl.cc ns-3.31/src/internet/model/nsc-tcp-socket-impl.cc
--- ns-3.30.1/src/internet/model/nsc-tcp-socket-impl.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/nsc-tcp-socket-impl.cc	2020-06-27 17:38:30.000000000 -0700
@@ -124,7 +124,7 @@
     m_nscTcpSocket (0),
     m_sndBufSize (sock.m_sndBufSize)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   NS_LOG_LOGIC ("Invoked the copy constructor");
   //copy the pending data if necessary
   if(!sock.m_txBuffer.empty () )
@@ -178,7 +178,7 @@
 enum Socket::SocketErrno
 NscTcpSocketImpl::GetErrno (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_errno;
 }
 
@@ -191,14 +191,14 @@
 Ptr<Node>
 NscTcpSocketImpl::GetNode (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_node;
 }
 
 void 
 NscTcpSocketImpl::Destroy (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_node = 0;
   m_endPoint = 0;
   m_tcp = 0;
@@ -206,7 +206,7 @@
 int
 NscTcpSocketImpl::FinishBind (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   if (m_endPoint == 0)
     {
       return -1;
@@ -221,7 +221,7 @@
 int
 NscTcpSocketImpl::Bind (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_endPoint = m_tcp->Allocate ();
   return FinishBind ();
 }
@@ -284,14 +284,14 @@
 int 
 NscTcpSocketImpl::ShutdownSend (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_shutdownSend = true;
   return 0;
 }
 int 
 NscTcpSocketImpl::ShutdownRecv (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_shutdownRecv = true;
   return 0;
 }
@@ -399,7 +399,7 @@
 uint32_t
 NscTcpSocketImpl::GetTxAvailable (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   if (m_txBufferSize != 0)
     {
       NS_ASSERT (m_txBufferSize <= m_sndBufSize);
@@ -456,9 +456,7 @@
 }
 
 Ptr<Packet>
-NscTcpSocketImpl::Recv (uint32_t maxSize, uint32_t flags)
-{
-  NS_LOG_FUNCTION_NOARGS ();
+NscTcpSocketImpl::Recv (uint32_t maxSize, uint32_tNS_LOG_FUNCTION (this)ON_NOARGS ();
   if (m_deliveryQueue.empty () )
     {
       m_errno = ERROR_AGAIN;
@@ -491,7 +489,7 @@
 int
 NscTcpSocketImpl::GetSockName (Address &address) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this << address);
   address = InetSocketAddress (m_localAddress, m_localPort);
   return 0;
 }
@@ -514,7 +512,7 @@
 uint32_t
 NscTcpSocketImpl::GetRxAvailable (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   // We separately maintain this state to avoid walking the queue 
   // every time this might be called
   return m_rxAvailable;
